//////////////////////////////////////////////////////////////////////////

function primary_rev_zone(zone) {

    D(
        zone,
        REG_NONE,
        DnsProvider(PDNS),
        NAMESERVER_TTL(62400),
        NAMESERVER('ns1.burble.dn42.'),
        DefaultTTL(3600)
    )
    
}

//////////////////////////////////////////////////////////////////////////

var z

//////////////////////////////////////////////////////////////////////////
// burble.dn42 zones

// ipv4 services range

z = REV('172.20.129.0/27')
primary_rev_zone(z)
rev4_map.push([
    IP('172.20.129.0'),
    IP('255.255.255.224'),
    z
])

// ipv4 nodes range

z = REV('172.20.129.160/27')
primary_rev_zone(z)
rev4_map.push([
    IP('172.20.129.160'),
    IP('255.255.255.224'),
    z
])

// ipv6 range

z = REV('fd42:4242:2601::/48')
primary_rev_zone(z)
rev6_map.push([ 'fd42:4242:2601', z ])

//////////////////////////////////////////////////////////////////////////
// elburb.dn42 fake zone

z = REV('fd8f:a4c9:1c03::/48')
primary_rev_zone(z)
rev6_map.push([ 'fd8f:a4c9:1c03', z ])

//////////////////////////////////////////////////////////////////////////
// dn42 reverse zones

// b.master.delegation-servers.dn42

z = REV('fd42:180:3de0:30::/60')
primary_rev_zone(z)
rev6_map.push([ 'fd42:180:3de0:30', z ])

D_EXTEND(
    z,
    PTR('fd42:180:3de0:30::1', 'b.master.delegation-servers.dn42.')
);


// dn42 registry services

z = REV('172.22.63.0/28')
primary_rev_zone(z)
rev4_map.push([
    IP('172.22.63.0'),
    IP('255.255.255.240'),
    z
])

D_EXTEND(
    z,
    PTR('172.22.63.1', 'route.git.dn42.'    ),
    PTR('172.22.63.2', 'git.dn42.'          ),
    PTR('172.22.63.3', 'drone.git.dn42.'    ),
    PTR('172.22.63.4', 'runners.git.dn42.'  )
);

z = REV('fd42:180:3de0:100::/60')
primary_rev_zone(z)
rev6_map.push([ 'fd42:180:3de0:100', z ])

D_EXTEND(
    z,
    PTR('fd42:180:3de0:100::1',                  'route.git.dn42.'   ),
    PTR('fd42:180:3de0:100:fc5f:3a14:838e:a7a7', 'git.dn42.'         ),
    PTR('fd42:180:3de0:100:42e6:9ff:fe09:bfc0',  'drone.git.dn42.'   ),
    PTR('fd42:180:3de0:100:216:3eff:fecd:471f',  'runners.git.dn42.' )    
);

z = REV('fd42:180:3de0:110::/60')
primary_rev_zone(z)
rev6_map.push([ 'fd42:180:3de0:110', z ])

//D_EXTEND(
//    rz_bdn42_regsvc6,
//    PTR('fd42:180:3de0:110:92ac:47ff:fe36:8769', 'gitea.regsvcs.uk-lon4.burble.dn42.'),
//    PTR('fd42:180:3de0:110:f2f9:d9ff:fea5:14ff', 'drone.regsvcs.uk-lon4.burble.dn42.')
//);

//////////////////////////////////////////////////////////////////////////
// end of file
